package com.officetetsu.puzzle;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.Gallery;
import android.widget.ImageView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Toast;

public class PhotoBrowser extends Activity 
	implements
	View.OnClickListener,
	DialogInterface.OnClickListener,
	OnItemClickListener{
	
	private ImageView imageView;
	private Gallery gallery;
	private String[] pictures;
	private String picturesroot;
	private String pictureFile;
	private Button button_sel, button_ini, button_can;
	
	private AlertDialog closeDialog;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.photobrowser);
		
		setResult(Activity.RESULT_CANCELED);
		
		closeDialog = new AlertDialog.Builder(this)
		.setTitle(R.string.app_name)
		.setNeutralButton("OK", this)
		.setCancelable(false)
		.create();
		
		String state = Environment.getExternalStorageState();
		if(	!Environment.MEDIA_MOUNTED.equals(state) && 
			!Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)
		){
			closeDialog.setMessage(getString(R.string.error_sd));
			closeDialog.show();
			return;
		}

		String sdroot = Environment.getExternalStorageDirectory().getPath();
		picturesroot = sdroot + "/Pictures";
		File picturesrootdir = new File(picturesroot);
		if(! picturesrootdir.exists()){
			closeDialog.setMessage(getString(R.string.error_picdir));
			closeDialog.show();
			return;
		}

		pictures = picturesrootdir.list();
		
		ArrayList<String> tmp = new ArrayList<String>();
		for(String s: pictures){
			if(s.endsWith("JPG") || s.endsWith("jpg"))
				tmp.add(s);
		}
		tmp.toArray(pictures);

		if(pictures.length == 0){
			closeDialog.setMessage(getString(R.string.error_pictures));
			closeDialog.show();
			return;
		}
		
		PhotoBrowserAdapter adapter = new PhotoBrowserAdapter(this, picturesroot, pictures);
		gallery = (Gallery)findViewById(R.id.gallery1b);
		gallery.setSpacing(2);
		gallery.setAdapter(adapter);
		gallery.setOnItemClickListener(this);
	
		imageView = (ImageView)findViewById(R.id.imageView1b);
		pictureFile = picturesroot + "/" + pictures[0];
		Bitmap picture = BitmapFactory.decodeFile(pictureFile);
		imageView.setImageBitmap(picture);

		button_sel = (Button)findViewById(R.id.button1b);
		button_ini = (Button)findViewById(R.id.button2b);
		button_can = (Button)findViewById(R.id.button3b);
		button_sel.setOnClickListener(this);
		button_ini.setOnClickListener(this);
		button_can.setOnClickListener(this);
	}

	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		// TODO Auto-generated method stub
		if(arg0 == gallery){
			pictureFile = picturesroot + "/" + pictures[arg2];
			Bitmap picture = BitmapFactory.decodeFile(pictureFile);
			imageView.setImageBitmap(picture);
		}
	}

	public void onClick(DialogInterface dialog, int which) {
		// TODO Auto-generated method stub
		if(dialog == closeDialog)
			finish();
	}

	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		if(arg0 == button_ini){
			if(deleteFile("def_photo.jpg")){
				Toast.makeText(this, R.string.message03, Toast.LENGTH_LONG).show();
				setResult(Activity.RESULT_OK);
			}
		} else
		if(arg0 == button_sel){
			byte[] buffer = new byte[256];
			int num;
			try{
				FileInputStream input = new FileInputStream(pictureFile);
				FileOutputStream output =
					openFileOutput("def_photo.jpg", Context.MODE_PRIVATE);
				while((num = input.read(buffer)) != -1){
					output.write(buffer, 0, num);
				}
				input.close();
				output.close();
			}
			catch (FileNotFoundException e){}
			catch (IOException e){}
			setResult(Activity.RESULT_OK);
			Toast.makeText(this, R.string.message03, Toast.LENGTH_LONG).show();
		}
		finish();		
	}
}
